{ Turbo Delphi }
program inverses;

{$APPTYPE CONSOLE}

uses
  SysUtils;
type Cartesian = record
 sz , k , pr ,l, r: int64;
end;
var D:array[0 .. 60000] of Cartesian;
 a:array[0 .. 60000] of int64;
 answer , tree , Len , n , q , t: int64;
 i : integer;
procedure upd(v : int64);
begin
 if v = 0 then exit;
 D[v].sz := D[D[v].l].sz + 1 + D[D[v].r].sz;
end;
function merge(l,r : int64) : int64;
begin
 if l*r = 0 then merge := l + r
 else
  if D[l].pr > D[r].pr then
  begin
   D[l].r := merge(D[l].r , r);
   result := l;
  end
  else
  begin
   D[r].l := merge(l, D[r].l);
   result := r;
  end;
  upd(result);
end;
procedure split(t,x : int64;var l,r : int64);
begin
 if t = 0 then
 begin
  l :=0 ;
  r := 0;
  exit;
 end;
 if D[t].k <= x then
 begin
  split(D[t].r, x , D[t].r , r);
  l := t;
 end
 else
 begin
  split(D[t].l , x , l, D[t].l);
  r := t;
 end;
 upd(l);upd(r);
end;
procedure add(k : int64);
var t1 , t2 : int64;
begin
 inc(Len);
 D[Len].k := k;
 D[len].pr := random(5000000);
 D[len].l := 0;
 D[Len].r := 0;
 D[Len].sz := 1;
 split(tree , k , t1,t2);
 t1 := merge(t1 , Len);
 tree := merge(t1 , t2);
end;
function find(tree : int64;x : int64) : int64;
begin
 if D[tree].sz= 0 then find := 0
 else
  if D[tree].k <= x then find:=find(D[tree].r,x)
   else
    find :=D[D[tree].r].sz + 1 + find(D[tree].l,x);
end;
begin
 randomize;
 assign(input,'inverses.in');reset(input);
 assign(output,'inverses.out');rewrite(output);
 tree := 0;
 Len := 0;
 readln(N,t);
 answer:= 0;
 for i:=1 to n do
 begin
  read(a[i]);
  q := a[i] + t;
  answer := answer + find(tree ,q);
  add(a[i]);
 end;
 readln;
 writeln(answer);
 close(input);
 close(output);
end.
