/* VC */
#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>

using namespace std;

struct Patient
{
	int when_he_comes;
	int interview;
	int wait_minutes;
	int when_he_left;
};


int main()
{
	ifstream infile("clinic.in");
	ofstream outfile("clinic.out");

	int n /*number of patients*/, t1, t2; // global declarations
	Patient *pPatients;

	int RecivePoint;

	vector <int> when_none;
	vector <int> when_busy;
	vector <int> with_someone_comes_time;
	vector <int> with_someone_waiting_time;
	vector <int> with_someone_waiting_time_d;

	infile >> n;
	infile >> t1;
	infile >> t2;

	RecivePoint = t1;

	pPatients = new Patient [n];

	for (int i = 0; i < n; i++)
	{
		infile >> pPatients[i].when_he_comes;
	}

	for (int i = 0; i < n; i++)
	{
		infile >> pPatients[i].interview;
	}

	for (int i = 0; i < n; i++)
	{
		if (pPatients[i].when_he_comes >= t2)
		{
			n = i;
			break;
		}

		if (pPatients[i].when_he_comes <= RecivePoint)
		{
			pPatients[i].wait_minutes = RecivePoint - pPatients[i].when_he_comes;
			pPatients[i].when_he_left = RecivePoint + pPatients[i].interview;
		} else
		{
			pPatients[i].wait_minutes = 0;
			pPatients[i].when_he_left = pPatients[i].when_he_comes + pPatients[i].interview;
			
		}
		RecivePoint = pPatients[i].when_he_left;

		cout << RecivePoint << endl;
	}

	for (int i = 0; i < n; i++)
	{
		cout << pPatients[i].when_he_left - pPatients[i].interview << " " << pPatients[i].when_he_left << "; " << pPatients[i].wait_minutes << endl;
	}

	for (int i = 0; i < n; i++)
	{
		with_someone_waiting_time_d.push_back(pPatients[i].wait_minutes); //Copy

		with_someone_waiting_time.push_back(pPatients[i].wait_minutes);
		with_someone_comes_time.push_back(pPatients[i].when_he_comes);

	}

	if (with_someone_waiting_time.size() > 0)
		sort(with_someone_waiting_time.begin(), with_someone_waiting_time.end());

	int num_of = 0, min_wait_time;

	min_wait_time = with_someone_waiting_time.at(0);

	for (int i = 0; i < n; i++)
	{
		if (min_wait_time == with_someone_waiting_time_d.at(i))
			when_busy.push_back(with_someone_comes_time.at(i));
	}
	if (when_busy.size() > 0)
		sort(when_busy.begin(), when_busy.end());

	//min_wait_time

	if ( ((pPatients[0].when_he_comes) >= t1) && (pPatients[0].when_he_comes < t2))
		when_none.push_back(t1);

	for (int i = 0; i < n - 1; i++)
	{
		if ( (pPatients[i + 1].when_he_left - pPatients[i + 1].interview) != pPatients[i].when_he_left )
			when_none.push_back(pPatients[i].when_he_left);
	}
	if (when_none.size() > 0)
		sort(when_none.begin(), when_none.end());

	if (when_none.size() > 0)
		outfile << when_none.at(0) << endl;
	else
		outfile << when_busy.at(0) << endl;

	delete [] pPatients;

	infile.close();
	outfile.close();

	return 0;
}