{ Turbo Delphi }
Program inverses;
Uses SysUtils;
type pair = record
  n, z: longint;
end;
var n, t, i, k, s, j: longint;
    fi, fo: text;
    x: array[1..50001] of pair;

function comp(l, r: pair): boolean;
  begin
    if l.z = r.z then comp := l.n < r.n else
    comp := l.z < r.z;
  end;

procedure sort(l, r: longint);
  var i, j: longint;
      etl, c: pair;
  begin
    if l < r then
      begin
        i := l; j := r;
        etl := x[random(r - l) + l];
        while i < j do
          begin
            while comp(x[i], etl) do inc(i);
            while comp(etl, x[j]) do dec(j);
            if i <= j then
              begin
                c := x[i]; x[i] := x[j]; x[j] := c;
                inc(i); dec(j);
              end;
          end;
        sort(l, j); sort(i, r);
      end;
  end;
Begin
  assign(fi, 'inverses.in');
  assign(fo, 'inverses.out');
  reset(fi); rewrite(fo);
  read(fi, n, t);
  randomize;
  for i := 1 to n do
    begin
      read(fi, x[i].z); x[i].n := i;
    end;
  sort(1, n);
  k := 0;
  s := 1;
  while (x[s].n = s)and(s <= 50001) do inc(s);
  for i := s to n do
    if x[i].n <> i then
    begin
      for j := s to n do
        if (((x[i].n>x[j].n)and(i < j)and(x[i].z + t < x[j].z)) or ((x[i].n<x[j].n)and(i > j)and(x[i].z > x[j].z + t)and(x[j].n = j))) then
          inc(k);
    end;
  writeln(fo, k);  
  close(fi); close(fo);
End.
