/* VC */
#include<cstdio>
#include<iostream>
#include<algorithm>
#include<queue>
using namespace std;
long long mass[100000];
long long mas[100000];
long long ukmas[100000];
int kol;
struct tree
{
	tree(int ls,int rs):l(ls),r(rs)
	{
		if(l==r)
			v=0;
		else
		{
			tl=new tree(l,(l+r)/2);
			tr=new tree((l+r)/2+1,r);
			
			v=tl->v+tr->v;
		}
	}
	int l;
	int r;
	long long v;
	tree* tl;
	tree* tr;
};

void change(tree* t,int r,long long v)
{
	if(t->l==t->r)
		t->v+=v;
	else
	{
		if(r<=(t->l+t->r)/2)
			change(t->tl,r,v);
		else
			change(t->tr,r,v);
		t->v=t->tl->v+t->tr->v;
	}
}
int bp(long long v)
{
	int l=0;
	int r=kol-1;
	while(abs(l-r)>1)
	{
		if(ukmas[(l+r)/2]<=v)
			l=(l+r)/2;
		else
			r=(l+r)/2;
	}
	if(ukmas[r]<=v)
		return r;
	else
		return l;

}
long long find(int l,int r,tree* t)
{
	if(t->l==l && t->r==r)
		return t->v;
	if(r<=(t->l+t->r)/2)
		return find(l,r,t->tl);
	if(l>(l+r)/2)
		return find(l,r,t->tr);
	return find(l,(t->l+t->r)/2,t->tl)+find((t->l+t->r)/2+1,r,t->tr);
}
int main()
{
	
	freopen("inverses.in","r",stdin);
	freopen("inverses.out","w",stdout);
	int n,t;
	cin>>n>>t;
	for(int i=0;i<n;i++)
	{
		scanf("%lld",&mas[i]);
		mass[i]=mas[i];
	}
	sort(mass,mass+n);
	kol=0;
	ukmas[0]=mass[0];
	kol++;
	for(int i=1;i<n;i++)
	{
		if(mass[i]!=mass[i-1])
		{
			ukmas[kol]=mass[i];
			kol++;
		}
	}
	tree* g=new tree(0,kol-1);
	long long ans=0;
	for(int i=n-1;i>=0;i--)
	{
		if(mas[i]-t>ukmas[0])
			ans+=find(0,bp(mas[i]-t-1),g);
		change(g,bp(mas[i]),1);
	}
	cout<<ans<<endl;
}