/* GCC */
#include <stdio.h>
#include <vector>
#include <ctime>

using namespace std;

int n, t, a[50000], cnt, l, r, mid, temp;

std::vector < int > v;

void read()
{
	scanf("%d %d", &n, &t);
	for(int i = 0; i < n; ++i)
		scanf("%d", a + i);
}

void binsearch(int &l, int &r, int temp)
{
	l = 0, r = v.size() - 1;
	while(r - l > 1)
	{	
		mid = (l + r) / 2;
		if(v[mid] < temp)
			l = mid + 1;
		else
			r = mid;
	}
}

void solve()
{
	for(int i = n - 1; i > 0; --i)
	{
		if(v.size() == 0)
			v.push_back(a[i]);
		else
		{
			binsearch(l, r, a[i]);
			
			if(a[i] > v[l])
				v.insert(v.begin() + l + 1, a[i]);
			else
				v.insert(v.begin() + l, a[i]);
		}
		
		binsearch(l, r, a[i - 1] - t);
		
		if(a[i - 1] > v[r] + t)
			cnt += r + 1;
		else if(a[i - 1] > v[l] + t)
			cnt += l + 1;
	}
	
	printf("%d\n", cnt);
}

int main()
{
    freopen("inverses.in", "r", stdin);
    freopen("inverses.out", "w", stdout);
  	   
    read();
    solve();
     
    return 0;
}
