{ Turbo Delphi }
program inverses;

{$APPTYPE CONSOLE}

uses
  SysUtils;

CONST NMax = 50000;
TYPE TRecord = Record
      Numb : LongInt;
      Index : Word;
     End;
     TArr = Array [1..NMax] Of TRecord;
VAR M: TArr;
    n: Word;
    t: LongInt;

PROCEDURE Swap(Var a,b: TRecord);
Var TempNumb: LongInt;
    TempIndex: Word;
Begin
 TempNumb:=a.Numb;
 a.Numb:=b.Numb;
 b.Numb:=TempNumb;
 TempIndex:=a.Index;
 a.Index:=b.Index;
 b.Index:=TempIndex;
End;

PROCEDURE QuickSort(Var M: TArr; L,R: Word);
Var etalon: TRecord;
    i, j: Word;
Begin
 i:=L; j:=R;
 etalon.Numb:=M[(i + j) div 2].Numb;
 While (i<j) Do
 Begin
   While (M[i].Numb>Etalon.Numb) Do Inc(i);
   While (M[j].Numb<Etalon.Numb) Do Dec(j);
   If i<=j Then
    Begin
     Swap(M[i],M[j]);
     Inc(i);
     Dec(j);
    End;
 End;
 If i<R Then QuickSort(M, i, R);
 If L<j Then QuickSort(M, L, j);
End;

PROCEDURE Get_Result(Var M: TArr; index, n: Word; Var Count: UInt64; t: LongInt);
Var i: Word;
Begin
 For i:=index+1 To n Do
  If (M[i].Index>M[index].Index) Then
   If (M[index].Numb>M[i].Numb + t)
      Then Inc(Count);
End;

PROCEDURE Read_Data(Var M: TArr; Var n: Word; Var t: LongInt);
Var i: Word;
Begin
  Read(n, t);
   For i:=1 To n Do
   Begin
    Read(M[i].Numb);
    M[i].Index:=i;
   End;
End;

PROCEDURE Solve(Var M: TArr; n: Word; t: LongInt);
Var i: Word;
    Count: UInt64;
Begin
 QuickSort(M, 1, n);
 Count:=0;
 i:=1;
 While (i<n) Do
  Begin
    Get_Result(M, i, n, Count, t);
    Inc(i);
  End;
 Writeln(Count);
End;

BEGIN
 Assign(input,'inverses.in');
 Reset(input);
 Assign(output,'inverses.out');
 Rewrite(output);
 Read_Data(M, n, t);
 Solve(M, n ,t);
 Close(output);
 Close(input);

END.
