/* GCC */
#include <iostream>
#include <stdio.h>
#include <memory.h>
#include <math.h>
#include <algorithm>
#include <time.h>

using namespace std;

int n, t;
long long ans;

int a[50010];
int b[50010];

void f(int l, int r)
{
	if (l >= r)
		return;

	int m = (l + r) / 2;
	f(l, m);
	f(m + 1, r);
	int i = l;
	int j = m + 1;

	int L = r - l + 1;
	for (int k = 0; k < L; ++k)
	{
		if (!(i == m + 1 || j == r + 1))
		{
			if (a[i] > a[j] + t) 
			{
				ans += (m + 1 - i);
				++j;
			}
			else
				++i;
		}
	}

	i = l;
	j = m + 1;
	for (int k = 0; k < L; ++k)
	{
		if (i != m + 1 && j != r + 1)
		{
			if (a[i] <= a[j])
				b[k] = a[i++];
			else
				b[k] = a[j++];
		}
		else
		{
			if (i == m + 1)
				b[k] = a[j++];
			else
				b[k] = a[i++];
		}
	}

	for (int k = 0; k < L; ++k)
		a[l + k] = b[k];
}

int main()
{
	freopen("inverses.in", "r", stdin);
	freopen("inverses.out", "w", stdout);
	scanf("%d %d", &n, &t);
	for (int i = 0; i < n; ++i)
		scanf("%d", &a[i]);
	f(0, n - 1);
    cout << ans << endl;
}