/* GCC */
//#include<iostream>
#include<fstream>

using namespace std;

int main() {
    int n;
    long t1, t2;
    long start[50001];
    long length[50001];
    long end[50001];
    ifstream fin("clinic.in");
    ofstream fout("clinic.out");
    
    fin >> n >> t1 >> t2;

    start[0] = 0;
    length[0] = t1;
    end[0] = t1;
    for (int i = 1; i <= n; i++) fin >> start[i];
    for (int i = 1; i <= n; i++) fin >> length[i];
    for (int i = 1; i <= n; i++) end[i] = -1;
    fin.close();

    long minWait = t1;
    long ppStart = 0;
    
    for (int i = 1; i <= n && start[i] < t2 && minWait != 0; i++) {
        if (end[i - 1] < start[i]) {
            end[i] = start[i] + length[i];
            minWait = 0;
            ppStart = end[i - 1];
        } else {
            end[i] = end[i - 1] + length[i];
            long wait = end[i - 1] - start[i];
            if (wait < minWait) {
                minWait = wait;
                ppStart = start[i];
            }
        }
    }
    if (start[n] < t2 && end[n] < t2 && minWait != 0) {
        minWait = 0;
        ppStart = end[n];
    }

    fout << ppStart << "\n";
    fout.close();
    
    //cin.get();
    //cin.get();
    return 0;
}
