/* VC */
#include <iostream>
#include <cstdio>
#include <set>
#include <map>
#include <string>
#include <queue>
#include <stack>
#include <vector>

using namespace std;

bool same[50][50];
vector <int> use_permutation[50];
int m , n , sym_cnt , permutation[50] , save[50] , C[50];
set <unsigned long long> Hash;
unsigned long long hash_base = 113;
long long dp[50][50] , cnk[50][50] , answer;
char c;
vector <int> graph[5000];
bool is_platon = true;

bool check(int pos_1 , int pos_2)
{
	if ( graph[pos_1].size() != graph[pos_2].size() )
		return false;
	vector <int> deg_1 , deg_2;
	for (int i = 0 ; i < graph[pos_1].size() ; i ++ )
		deg_1.push_back(graph[graph[pos_1][i]].size());
	for (int i = 0 ; i < graph[pos_2].size() ; i ++ )
		deg_2.push_back(graph[graph[pos_2][i]].size());
	sort(deg_1.begin() , deg_1.end());
	sort(deg_2.begin() , deg_2.end());
	return deg_1 == deg_2;
};
/*
unsigned long long hash_calculate(int *a)
{
	unsigned long long answer = 0;
	for (int i = 1 ; i <= n ; i ++ )
		answer = answer * hash_base + a[i];
	return answer;
};

void fill_group(int *a)
{
	if ( Hash.find(hash_calculate(a)) != Hash.end() )
		return;
	Hash.insert(hash_calculate(a));
	int *b = new int[n + 1];
	for (int k = 1 ; k <= n ; k ++ )
		b[k] = a[k];
	for (int i = 1 ; i <= n ; i ++ )
		for (int j = i + 1 ; j <= n ; j ++ )
			if ( same[i][j] )
			{
				swap(b[i] , b[j]);
				fill_group(b);
				swap(b[i] , b[j]);
			};
	for (int i = 1 ; i <= n ; i ++ )
		for (int j = 0 ; j < use_permutation[i].size() ; j ++ )
		{
			for (int k = 1 ; k <= n ; k ++ )
				C[k] = b[k] = a[k];
			for (int k = 0 ; k < graph[i].size() ; k ++ )
			{
				int v = graph[i][k];
				int u = graph[i][(k + use_permutation[i][j])%graph[i].size()];
				b[v] = C[u];
			};
			fill_group(b);
		};
};
*/
int main()
{
	freopen("farben.in","r",stdin);
	freopen("farben.out","w",stdout);
	scanf("%d\n",&m);
	for (int i = 1 ; ; i ++ , n ++ )
	{
		int cur_num = 0 ;
		while ( ~scanf("%c",&c) && c != 10 )
			if ( c == ' ' )
				graph[i].push_back(cur_num) , cur_num = 0;
			else
				cur_num = cur_num * 10 + c - '0';
		if ( cur_num )
			graph[i].push_back(cur_num);
		if ( graph[i].empty() )
			break;
		is_platon &= graph[i].size() == graph[1].size();
	};
	if ( m == 1 || m == n )
	{
		printf("1\n");
		return 0;
	};
	for (int i = 1 ; i <= n ; i ++ )
		for (int j = 0 ; j < graph[i].size() ; j ++ )
			if ( check(i , graph[i][j]) )
				same[i][graph[i][j]] = true;

	cnk[0][0] = 1;
	for (int i = 1 ; i <= m ; i ++ )
	{
		cnk[i][0] = 1;
		for (int j = 1 ; j <= i ; j ++ )
			cnk[i][j] = cnk[i - 1][j] + cnk[i - 1][j - 1];
	};
	dp[0][0] = 1;
	for (int i = 1 ; i <= m ; i ++ )
		for (int j = 1 ; j <= n ; j ++ )
			for (int k = 0 ; k < j ; k ++ )
				dp[j][i] += dp[k][i - 1];
	for (int i = 1 ; i <= m ; i ++ )
		answer += dp[n][i] * cnk[m][i];

	int Color[50] , cnt = 0 , Val[50];
	memset(Color , 0 , sizeof(Color) );
	memset(Val , 0 , sizeof(Val) );
	for (int i = 1 ; i <= n ; i ++ )
	{
		if ( !Color[i] )
			Color[i] = ++cnt;
		Val[Color[i]] ++ ;
		queue <int> q;
		q.push(i);
		while ( !q.empty() )
		{
			int v = q.front();
			q.pop();
			for (int j = 1 ; j <= n ; j ++ )
				if ( same[v][j] && !Color[j] )
				{
					Color[j] = cnt;
					q.push(j);
				};
		};
	};
	long long global_answer = 1;
	for (int i = 1 ; i <= cnt ; i ++ )
	{
		long long local_answer = 0;
		for (int j = 1 ; j <= m ; j ++ )
			local_answer += dp[Val[i]][j] * cnk[m][j];
		global_answer *= local_answer;
	};
	cout << global_answer << endl;
	/*
	for (int i = 1 ; i <= n ; i ++ )
		sort(graph[i].begin() , graph[i].end() );

	for (int i = 1 ; i <= n ; i ++ )
		permutation[i] = i;

	for (int i = 1 ; i <= n ; i ++ )
	{
		vector <int> deg;
		for (int j = 0 ; j < graph[i].size() ; j ++ )
			deg.push_back(graph[graph[i][j]].size());
		for (int j = 1 ; j < deg.size() ; j ++ )
		{
			bool ok = true;
			for (int k = 0 ; k < deg.size() ; k ++ )
				if ( deg[k] != deg[(k + j)%deg.size()] )
					ok = false;
			if ( ok )
				use_permutation[i].push_back(j);
		};
	};

	if ( is_platon )
	{
		sym_cnt = 1;
		cout << answer * sym_cnt << endl;
		return 0;
	};

	do
	{
		if ( Hash.find(hash_calculate(permutation)) != Hash.end() )
			continue;
		sym_cnt ++ ;
		for (int i = 1 ; i <= n ; i ++ )
			save[i] = permutation[i];
		fill_group(save);
	} while ( next_permutation(permutation + 1 , permutation + n + 1) );
	cout << answer * sym_cnt << endl;*/
	return 0;
};