/* GCC */

#include <cstdlib>
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>

using namespace std;

const int nmax = 50010;

int n , t;
long long pos , ans;
int mas[ nmax ]; 

int l[ 2*nmax ] ;

int tree[ 10*nmax ];

int d;

void add( int v , int l , int r )
{
     if( l == r )
     {
         ++tree[v];
         return;
     }
     int md = (l+r)>>1;
     if( d <= md )
     add( 2*v , l , md );
     else 
     add( 2*v+1 , md+1 , r );
     
     tree[ v ] = tree[ 2*v ] + tree[ 2*v + 1 ]; 
     return;   
}

int get( int v , int l , int r , int tl , int tr )
{
    if( l==tl && r==tr )
    return tree[ v ];
    
    int md = (l+r)>>1;
    
    if( tr <= md )
    return get( 2*v , l , md , tl , tr );
    if( tl > md )
    return get( 2*v+1 , md+1 , r , tl , tr );
    return get( 2*v , l , md , tl , md ) + get( 2*v+1 , md+1 , r , md+1 , tr );
}

int len = 0;
int bin( int x )
{
    int ll = 0 , r = len-1;
    while( r - ll > 1 )
    {
           int md = (ll+r)>>1;
           if( l[md] > x )
           r = md;
           else ll = md;
    }
    if( l[r]==x )
    return r;
    
    return ll;
}

int main()
{
    freopen( "inverses.in" , "r" , stdin );
    freopen( "inverses.out" , "w" , stdout );
    scanf( "%d %d\n" , &n , &t );
    
    
    for( int i = 0 ; i < n ; ++i )
    {
       scanf( "%d" , mas+i );
       l[ len++ ] = mas[i];
       l[ len++ ] = mas[i]+t;
    }
    //++len;
    sort( l , l + len );
    unique( l , l + len );
    
    int i = 1;
    
  
    while( i < len )
    {
          if( l[i] == l[i-1] )
          {
              len = i;
          }
          ++i;
    }
    
    d = bin( mas[0] );//lower_bound( l , l+len , mas[0] )-l+1;
    
    int R = 2*len+10;
    
    add( 1 , 1 , R );
    for( int i = 1 ; i < n ; ++i )
    {
        d = bin( mas[i]+t );//lower_bound( l , l+len , mas[i]+t )-l+1;
        ans += get( 1 , 1 , R ,  d+1 , R );
        
        d = bin( mas[i] );//lower_bound( l , l+len , mas[i] )-l+1;
        
        add( 1 , 1 , R );
    }
    cout << ans << endl;
   // cout << clock() << endl;
    return 0;
}
