/* GCC */
#include <iostream>

using namespace std;

int n, t, a[50010], c[50010];
long long ans = 0;

void merge( int fl, int fr, int sr )
{
     int sl = fr + 1, i = fl, prev_i = fl, j = sl, q = fl;
     while( i <= fr && j <= sr )
     {
            while( a[j] >= a[prev_i] && prev_i <= fr ) c[q] = a[prev_i], q++, prev_i++;
            if( prev_i > i ) 
            {
                i = prev_i;
                if( i > fr ) break;
            }
            if( a[i] > a[j] + t ) c[q] = a[j], q++, j++, ans += fr - i + 1; else i++;
     }
     while( prev_i <= fr && j <= sr )
     {
            if( a[prev_i] <= a[j] ) c[q] = a[prev_i], prev_i++; else c[q] = a[j], j++;
            q++;
     }
     while( prev_i <= fr ) c[q] = a[prev_i], q++, prev_i++;
     for( int r = fl; r < q; r++ ) a[r] = c[r];
     return;
}

void work( int l, int r )
{
     if( l == r ) return;
     int m = ( l + r ) >> 1;
     work( l, m );
     work( m + 1, r );
     merge( l, m, r );
     return;
}

int main()
{
    freopen("inverses.in", "r", stdin);
    scanf("%d%d", &n, &t);
    for( int i = 0; i < n; i++ ) scanf("%d", &a[i]);
    fclose(stdin);
    work( 0, n - 1 );
    freopen("inverses.out", "w", stdout);
    printf("%d\n", ans);
    fclose(stdout);
    return 0;
}
