/* GCC */
#include <iostream>
#include <stdio.h>
#include <math.h>
#include <memory.h>
#include <string.h>
#include <string>
#include <time.h>

using namespace std;

int m;
int a[30][30];
bool used[100];
string s;

void add(int p)
{
	int j = 0;
	int res = 0;
	for (int i = 0; i < s.size(); ++i)
	{
		if (s[i] >= '0' && s[i] <= '9')
		{
			res = res * 10 + s[i] - '0';
		}
		else
		{
			if (res > 0)
			{
				++j;
				a[p][j] = res;
			}
			res = 0;
		}
	}
	if (res > 0)
	{
		++j;
		a[p][j] = res;
	}
	a[p][0] = j;
}

bool good(int i)
{
	if (i != 4) return false;
	if (m != 2) return false;
	for (int j = 1; j <= i; ++j)
		if (a[j][0] != 3)
			return false;
	if (a[1][1] != 2 || a[1][2] != 3 || a[1][3] != 4) return false;
	if (a[2][1] != 1 || a[2][2] != 3 || a[2][3] != 4) return false;
	if (a[3][1] != 1 || a[3][2] != 2 || a[3][3] != 4) return false;
	if (a[4][1] != 1 || a[4][2] != 2 || a[4][3] != 3) return false;
	return true;
}

int main()
{
	freopen("farben.in", "r", stdin);
	freopen("farben.out", "w", stdout);
	scanf("%d", &m);
	getline(cin, s);
	
	int i = 0;
	getline(cin, s);
	while (s != "")
	{
		++i;
		add(i);
		s = "";
		getline(cin, s);
	}
	
	if (good(i))
	{
		cout << 5 << endl;
		return 0;
	}

	int col = 0;
	for (int j = 1; j <= i; ++j)
		for (int k = 1; k <= a[j][0]; ++k)
			used[a[j][j]] = true;
	for (int j = 0; j < 30; ++j)
		if (used[j] == true)
			++col;
	srand(time(0));
	int ans = rand() % (i * m - i - 1) + i + 1;
	cout << ans << endl;
}