/* VC */
#include <iostream>
#include <cstdio>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <queue>
#include <stack>

using namespace std;

const int NMAX = 110000;
const int INF = 2e9;

int n , t_min , t_max , tin[NMAX] , visit_len[NMAX] , enter[NMAX] , prev_out , x_ans , answer = INF;

int main()
{
	freopen("clinic.in","r",stdin);
	freopen("clinic.out","w",stdout);
	scanf("%d%d%d",&n,&t_min,&t_max);
	for (int i = 1 ; i <= n ; i ++ )
		scanf("%d",&tin[i]);
	for (int i = 1 ; i <= n ; i ++ )
		scanf("%d",&visit_len[i]);
	prev_out = t_min;
	for (int i = 1 ; i <= n ; i ++ )
	{
		prev_out = max(prev_out , tin[i]);
		enter[i] = (prev_out >= t_max) ? -1 : prev_out;
		if ( prev_out < t_max )
			prev_out += visit_len[i];
	};
	while ( enter[n] == -1 )
		--n;
	if ( enter[n] + visit_len[n] < t_max )
	{
		answer = 0;
		x_ans = enter[n] + visit_len[n];
	};
	for (int i = 1 ; i <= n ; i ++ )
	{
		if ( i != 1 && enter[i - 1] + visit_len[i - 1] < tin[i] )
		{
			answer = 0;
			x_ans = enter[i - 1] + visit_len[i - 1];
		};
		if ( answer > enter[i] - tin[i] )
		{
			answer = enter[i] - tin[i];
			x_ans = tin[i];
		};
	};
	if ( tin[1] > t_min )
	{
		answer = 0;
		x_ans = t_min;
	};
	printf("%d\n",x_ans);
	return 0;
};
