/* VC */
#include <iostream>
#include <cstdio>
#include <set>
#include <map>
#include <string>
#include <queue>
#include <stack>
#include <ctime>

using namespace std;

const int NMAX = 51000;

int n , t , A[NMAX] , B[NMAX];

void merge(int L_1 , int R_1 , int L_2 , int R_2)
{
	int it = 1;
	for (int i = L_1 ; i <= R_1 ; i ++ )
	{
		for ( ; L_2 <= R_2 && A[L_2] < A[i] ; L_2 ++ )
			B[it ++ ] = A[L_2];
		B[it ++ ] = A[i];
	};
	for ( ; L_2 <= R_2 ; L_2 ++ )
		B[it ++ ] = A[L_2];
	for (int i = 1 ; i < it ; i ++ )
		A[L_1 + i - 1] = B[i];
};

int go(int L , int R)
{
	if ( L == R )
		return 0;
	int M = (L + R) >> 1;
	int answer = go(L , M) + go(M + 1 , R);
	int it = R;
	while ( it > M + 1 && A[it] + t >= A[L] )
			it -- ;
	for (int i = L ; i <= M ; i ++ )
	{
		while ( it <= R && A[it] + t < A[i] )
			it ++ ;
		answer += (it - M - 1);
	};
	merge(L , M , M + 1 , R);
	return answer;
};

int main()
{
	freopen("inverses.in","r",stdin);
	freopen("inverses.out","w",stdout);
	srand(time(NULL));
	scanf("%d%d",&n,&t);
	for (int i = 1 ; i <= n ; i ++ )
		scanf("%d",&A[i]);
	printf("%d\n",go(1 , n) );
	return 0;
};
