/* VC */
#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <memory.h>
#include <set>
#include <cstdlib>
#include <cstdio>
using namespace std;
#define mp make_pair
#define ll long long
#define pb push_back
struct tr
{
	int key,pr,cnt,L,R;
	tr(int key=0):key(key),pr(rand()),cnt(1),L(0),R(0){}
};
tr T[50001];
int cnt(int v)
{return (v==0)?0:T[v].cnt;}
void upd(int v)
{if (v)T[v].cnt=1+cnt(T[v].L)+cnt(T[v].R);}
void Split(int t,int &l,int &r,int key)
{
	if (!t)
	{l=r=0;}
	else
	{
		if (T[t].key<=key)
		{Split(T[t].R,T[t].R,r,key);l=t;}
		else
		{Split(T[t].L,l,T[t].L,key);r=t;}
		upd(l);upd(r);
	}
}
void Merge(int l,int r,int &t)
{
	if (!l)
	{t=r;}
	else
	{
		if (!r)
		{t=l;}
		else
		{
			if (T[l].pr<T[r].pr)
			{
				Merge(T[l].R,r,T[l].R);
				t=l;
			}
			else
			{
				Merge(l,T[r].L,T[r].L);
				t=r;
			}
			upd(t);
		}
	}
}
void print(int v,int ws=0)
{
	if (!v){for (int i=0;i<ws;i++)cout<<" ";cout<<"NULL"<<endl;return;}
	print(T[v].R,ws+5);
	for (int i=0;i<ws;i++)cout<<" ";
	cout<<T[v].key<<" p "<<T[v].pr<<" c "<<T[v].cnt<<" l "<<T[v].L<<" r "<<T[v].R<<endl;
	print(T[v].L,ws+5);
}
int n,t,root,a,l,r,i;
int main()
{
	srand(31416);
	freopen("inverses.in","r",stdin);
	freopen("inverses.out","w",stdout);
	scanf("%d%d",&n,&t);
	ll rez=0;
	for (i=1;i<=n;++i)
	{
		scanf("%d",&a);
		Split(root,l,r,a+t);
		rez+=(ll)cnt(r);
		Merge(l,r,root);
		Split(root,l,r,a);
		T[i]=tr(a);
		Merge(l,i,root);
		Merge(root,r,root);
	}
	cout<<rez<<endl;
}